// ======================== Atmega128 ؽƮ LCD α׷ =====================
//  CPU : ATmega128-16M - ؽƮ LCD(2*16)
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega128.h>							// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>
#include <delay.h>

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// PortA 
// LCD_D[0..7] : LCD Data Bus
	PORTA=0xff;						// Ʈ  reg
	DDRA=0x00;                                              // Ʈ  reg(0Է,1)

// PortC 
// LCD_D[8..15] : LCD Data Bus(color lcd)
// PortC.0 : LCD_CS1
// PortC.1 : LCD_CS2
	PORTC=0xfc;						// Ʈ  reg
	DDRC=0x03;                                              // Ʈ  reg(0Է,1)

// PortE 
// PortE.3(OUT) : LCD DIR
// PortE.4(OUT) : LCD E
// PortE.5(OUT) : LCD RS
// PortE.6(OUT) : GLCD/CLCD Reset
// PortE.7(IN)  : TSC2003 Interrupt PULL UP(external)
	PORTE=0x40;						// Ʈ  reg
	DDRE=0x78;                                              // Ʈ  reg(0Է,1)

// PortG 
// PortG.0(OUT) : LCD R/W,CLCD_WR
// PortG.1(OUT) : LCD RD
// PortG.2(OUT) : LCD CS
	PORTG=0x07;						// Ʈ  reg
	DDRG=0x07;                                              // Ʈ  reg(0Է,1)

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): 1r/w
//	MCUCR=0xc0;
//	XMCRA=0x02;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART0_RXC] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

#include "textlcd.inc"							// Text LCD
// ============================ ؽƮ LCD  α׷ ======================
//      : 2*16 LCD
// ----------------------------------------------------------------------------
// LCD  
#define	SCREEN1		0
#define	SCREEN2		1

#define	OFF		0
#define	ON		1

// Լ 
void Clrscr(void);						// ȭ 

void Cursor_Set(char sts);					// Ŀ  
void Gotoxyt(char x, char y);					// ؽƮ ǥ

void Putch(char data);						// 1 ǥ
void Putchxyt(char x, char y,char data);			// ؽƮ ǥ  ǥ

// SRAM  ǥ
void Puts(char stbuf[]);					// LCD ڿ 
void Putsxyt(char x, char y,char dbuf[]);			// ؽƮ ǥ ڿ ǥ
// FLASH ޸ ڿ ǥ
void Puts_f(char flash stbuf[]);				// LCD ڿ(FLASH) 
void Putsxyt_f(char x, char y,char flash dbuf[]);		// ؽƮ ǥ ڿ(FLASH) ǥ

void LCD_Init(void);						// GLCD Init
void LCD_Busy(void);						// LCD Busy Check
void LCD_Command(unsigned char uch);				// COMMAND Write
void LCD_Dwrite(unsigned char uch);				// DATA Write
unsigned char LCD_Dread(void);					// DATA 

//  

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char sts
// Item1: Ŀ (0,(OFF),1(ON))
// Item2: Ŀ ǥ ġ(SCREEN0,SCREEN1)
/// ----------------------------------------------------------------------------
void Cursor_Set(char sts)
{
	if(sts == OFF) LCD_Command(0x0c);			// CURSOR OFF/BLINK OFF
	else LCD_Command(0x0f);					// CURSOR ON/BLINK ON(0x0e)
}

// ================================ ȭ Ұ ==================================
// [μ] void
/// ----------------------------------------------------------------------------
void Clrscr(void)
{
	LCD_Command(0x01);					// ALL CLEAR
}

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char x,char y
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
/// ----------------------------------------------------------------------------
void Gotoxyt(char x, char y)
{
char xx = x-1,yy = y-1;

	LCD_Busy();
	switch(yy){
		case 0: LCD_Command(0x80+xx); break;
		case 1: LCD_Command(0xc0+xx); break;
	}
}

// ==================================  ǥ ================================
// [μ] char data
// Item1: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putch(char data)
{
	LCD_Dwrite(data);					//  ǥ
}

// ============================  ġ  ǥ ===========================
// [μ] char x,char y,char data
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putchxyt(char x, char y,char data)
{
	Gotoxyt(x,y);						// ǥ 
	LCD_Dwrite(data);					//  ǥ
}

// ============================= LCD1 ڿ  ===========================
// [μ] char str[]
// Item1: ɾ
// ----------------------------------------------------------------------------
void Puts(char stbuf[])
{
char *pstr = 0;

	pstr = stbuf;
	while(*pstr) LCD_Dwrite(*pstr++);			// ڿ 
}

// ========================== LCD1 FLASH ڿ  ========================
// [μ] char flash str[]
// Item1: ɾ
// ----------------------------------------------------------------------------
void Puts_f(char flash stbuf[])
{
	while(*stbuf) LCD_Dwrite(*stbuf++);			// ڿ 
}

// ===========================  ġ ڿ ǥ =========================
// [μ] char x,char y,char dbuf[]
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putsxyt(char x, char y,char dbuf[])
{
	Gotoxyt(x,y);						// ǥ 
	Puts(dbuf);						// ڿ ǥ
}

// =======================  ġ flash ڿ ǥ =======================
// [μ] char x,char y,char flash dbuf[]
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putsxyt_f(char x, char y,char flash dbuf[])
{
	Gotoxyt(x,y);						// ǥ 
	while(*dbuf) LCD_Dwrite(*dbuf++);			// ڿ 
}

// ================================= LCD ʱȭ ===============================
// [μ] void
// ----------------------------------------------------------------------------
void LCD_Init(void)
{
	delay_ms(50);
	LCD_Command(0x38);
	delay_ms(100);
	LCD_Command(0x38);
	delay_ms(200);
	LCD_Command(0x38);					// FUNCTION SET
	LCD_Command(0x0c);					// DISP ON/CURSOR/BLINK ON
	LCD_Command(0x06);					// ENTRY MODE

	LCD_Command(0x01);					// ALL CLEAR
	delay_ms(100);
}

// =================================== BUSY Check ============================
// [μ] void
// ---------------------------------------------------------------------------
void LCD_Busy(void)
{
unsigned char i,ch;

	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	PORTG |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);					// delay
	ch = PINA & 0x80;					// LCD DATA Read :: BUSY BIT
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);
	while(ch == 0x80){
		PORTE |= 0x10;					// PORTE.4 :: LCD_E = 1
		for(i = 0; i < 3; i++);
		ch = PINA & 0x80;				// LCD DATA Read :: BUSY BIT
		PORTE &= 0xef;					// PORTE.4 :: LCD_E = 0
		for(i = 0; i < 3; i++);
	}
}

// ============================== COMMAND  write =======================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Command(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	PORTG &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write
	PORTA = uch;						// PORTA = uch
	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  write ==========================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Dwrite(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	PORTG &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write
	PORTA = uch;						// PORTA = uch
	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  read ===========================
// [μ] void
// [] (0-0xff)
// ---------------------------------------------------------------------------
unsigned char LCD_Dread(void)
{
unsigned char i,uch;

	LCD_Busy();						// BUSY Check
	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	PORTG |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 5; i++);					// delay
	uch = PINA & 0xff;					// LCD DATA Read :: BUSY BIT
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);
	return(uch);						//  read
}

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char lcd_buf[25];

	cpu_setup();							// cpu ʱȭ
	LCD_Init();							// LCD ʱȭ
	main_menu_disp();						//  ޴ ǥ
	Putsxyt_f(1,1,"  MEGA128_Clcd  ");
	Putsxyt_f(1,2,"www.cpuplaza.com");
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '3') Putchxyt(1,1,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '4'){
				sprintf(lcd_buf,"123");			// ǥ ڿ
				Puts(lcd_buf);
			}
			else if(com1_rx_data == '5'){			// ؽƮ ǥ ڿ ǥ
				sprintf(lcd_buf,"LCD TEST LINE1");	// ǥ ڿ
				Putsxyt(1,1,lcd_buf);
				sprintf(lcd_buf,"LCD TEST LINE2");	// ǥ ڿ
				Putsxyt(1,2,lcd_buf);
			}
			else if(com1_rx_data == '6') Puts_f("123");	// ǥ ڿ(FLASH)
			else if(com1_rx_data == '7'){			// ؽƮ ǥ ڿ(FLASH) ǥ
				Putsxyt_f(1,1,"LCD TEST LINE1");
				Putsxyt_f(1,2,"LCD TEST LINE2");
			}
			else if(com1_rx_data == '8') Cursor_Set(ON);	// Ŀ ON
			else if(com1_rx_data == '9') Cursor_Set(OFF);	// Ŀ OFF
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========== LCD Test Main =========\r\n");
	printf("- 1 : Clrscr                     -\r\n");
	printf("- 2 : Putch                      -\r\n");
	printf("- 3 : Putchxyt                   -\r\n");
	printf("- 4 : Puts                       -\r\n");
	printf("- 5 : Putsxyt                    -\r\n");
	printf("- 6 : Puts_f                     -\r\n");
	printf("- 7 : Putsxyt_f                  -\r\n");
	printf("- 8 : Cursor ON                  -\r\n");
	printf("- 9 : Cursor OFF                 -\r\n");
	printf("----------------------------------\r\n");
}

