// ============================ ؽƮ LCD  α׷ ======================
//      : 2*16 LCD
// ----------------------------------------------------------------------------
// LCD  
#define	SCREEN1		0
#define	SCREEN2		1

#define	OFF		0
#define	ON		1

// Լ 
void Clrscr(void);						// ȭ 

void Cursor_Set(char sts);					// Ŀ  
void Gotoxyt(char x, char y);					// ؽƮ ǥ

void Putch(char data);						// 1 ǥ
void Putchxyt(char x, char y,char data);			// ؽƮ ǥ  ǥ

// SRAM  ǥ 
void Puts(char stbuf[]);					// LCD ڿ 		
void Putsxyt(char x, char y,char dbuf[]);			// ؽƮ ǥ ڿ ǥ
// FLASH ޸ ڿ ǥ
void Puts_f(char flash stbuf[]);				// LCD ڿ(FLASH) 		
void Putsxyt_f(char x, char y,char flash dbuf[]);		// ؽƮ ǥ ڿ(FLASH) ǥ

void LCD_Init(void);						// GLCD Init
void LCD_Busy(void);						// LCD Busy Check
void LCD_Command(unsigned char uch);				// COMMAND Write
void LCD_Dwrite(unsigned char uch);				// DATA Write
unsigned char LCD_Dread(void);					// DATA 

//  

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char sts
// Item1: Ŀ (0,(OFF),1(ON))
// Item2: Ŀ ǥ ġ(SCREEN0,SCREEN1)
/// ----------------------------------------------------------------------------
void Cursor_Set(char sts)
{
	if(sts == OFF) LCD_Command(0x0c);			// CURSOR OFF/BLINK OFF
	else LCD_Command(0x0f);					// CURSOR ON/BLINK ON(0x0e)
}

// ================================ ȭ Ұ ==================================
// [μ] void
/// ----------------------------------------------------------------------------
void Clrscr(void)
{
	LCD_Command(0x01);					// ALL CLEAR
}

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char x,char y
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
/// ----------------------------------------------------------------------------
void Gotoxyt(char x, char y)
{
char xx = x-1,yy = y-1;

	LCD_Busy();
	switch(yy){
		case 0: LCD_Command(0x80+xx); break;  
		case 1: LCD_Command(0xc0+xx); break;
	}
}

// ==================================  ǥ ================================
// [μ] char data
// Item1: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putch(char data)
{
	LCD_Dwrite(data);					//  ǥ
}

// ============================  ġ  ǥ ===========================
// [μ] char x,char y,char data
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putchxyt(char x, char y,char data)
{
	Gotoxyt(x,y);						// ǥ 
	LCD_Dwrite(data);					//  ǥ
}

// ============================= LCD1 ڿ  ===========================
// [μ] char str[]
// Item1: ɾ
// ----------------------------------------------------------------------------
void Puts(char stbuf[])
{
char *pstr = 0;

	pstr = stbuf;
	while(*pstr) LCD_Dwrite(*pstr++);			// ڿ 
}

// ========================== LCD1 FLASH ڿ  ========================
// [μ] char flash str[]
// Item1: ɾ
// ----------------------------------------------------------------------------
void Puts_f(char flash stbuf[])
{
	while(*stbuf) LCD_Dwrite(*stbuf++);			// ڿ 
}

// ===========================  ġ ڿ ǥ =========================
// [μ] char x,char y,char dbuf[]
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putsxyt(char x, char y,char dbuf[])
{
	Gotoxyt(x,y);						// ǥ 
	Puts(dbuf);						// ڿ ǥ
}

// =======================  ġ flash ڿ ǥ =======================
// [μ] char x,char y,char flash dbuf[]
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putsxyt_f(char x, char y,char flash dbuf[])
{
	Gotoxyt(x,y);						// ǥ 
	while(*dbuf) LCD_Dwrite(*dbuf++);			// ڿ 
}

// ================================= LCD ʱȭ ===============================
// [μ] void
// ----------------------------------------------------------------------------
void LCD_Init(void)
{
	delay_ms(50);
	LCD_Command(0x38);
	delay_ms(100);
	LCD_Command(0x38);
	delay_ms(200);
	LCD_Command(0x38);					// FUNCTION SET
	LCD_Command(0x0c);					// DISP ON/CURSOR/BLINK ON
	LCD_Command(0x06);					// ENTRY MODE
	
	LCD_Command(0x01);					// ALL CLEAR
	delay_ms(100);
}

// =================================== BUSY Check ============================
// [μ] void
// ---------------------------------------------------------------------------
void LCD_Busy(void)
{
unsigned char i,ch;

	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	PORTG |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);					// delay
	ch = PINA & 0x80;					// LCD DATA Read :: BUSY BIT
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);	
	while(ch == 0x80){
		PORTE |= 0x10;					// PORTE.4 :: LCD_E = 1
		for(i = 0; i < 3; i++);	
		ch = PINA & 0x80;				// LCD DATA Read :: BUSY BIT
		PORTE &= 0xef;					// PORTE.4 :: LCD_E = 0
		for(i = 0; i < 3; i++);	
	}
}

// ============================== COMMAND  write =======================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Command(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE &= 0xdf;						// PORTE.5 :: LCD RS = 0 :: Instruction Set
	PORTG &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write	
	PORTA = uch;						// PORTA = uch
	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  write ==========================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Dwrite(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check
	DDRA = 0xff;						// LCD_D[0..7] OUTPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	PORTG &= 0xfe;						// PORTG.0 :: LCD_R/W\ = Write	
	PORTA = uch;						// PORTA = uch
	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  read ===========================
// [μ] void
// [] (0-0xff)
// ---------------------------------------------------------------------------
unsigned char LCD_Dread(void)
{
unsigned char i,uch;

	LCD_Busy();						// BUSY Check
	PORTA = 0xff;						// PORTA = PULL UP
	DDRA = 0x00;						// LCD_D[0..7] INPUT Mode Set

	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	PORTE |= 0x20;						// PORTE.5 :: LCD RS = 1 :: Data Set
	PORTG |= 0x01;						// PORTG.0 :: LCD_R/W\ = Read

	PORTE |= 0x10;						// PORTE.4 :: LCD_E = 1
	for(i = 0; i < 5; i++);					// delay
	uch = PINA & 0xff;					// LCD DATA Read
	PORTE &= 0xef;						// PORTE.4 :: LCD_E = 0
	for(i = 0; i < 3; i++);	
	return(uch);						//  read
}
